# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`wormhole`](#wormhole): Manage magic-wormhole

#### Private Classes

* `wormhole::package`: Manage the wormhole package

### Tasks

* [`receive`](#receive): Receive a file from a remote location
* [`send`](#send): Send a file from a remote location

## Classes

### <a name="wormhole"></a>`wormhole`

Manage magic-wormhole

#### Parameters

The following parameters are available in the `wormhole` class:

* [`manage_package`](#manage_package)
* [`package_name`](#package_name)
* [`package_ensure`](#package_ensure)
* [`package_provider`](#package_provider)

##### <a name="manage_package"></a>`manage_package`

Data type: `Boolean`

Whether the wormhole package should be managed by the module

Default value: ``true``

##### <a name="package_name"></a>`package_name`

Data type: `String`

Name of the wormhole package

Default value: `'magic-wormhole'`

##### <a name="package_ensure"></a>`package_ensure`

Data type: `String`

Ensure value for the wormhole package resource

Default value: `'installed'`

##### <a name="package_provider"></a>`package_provider`

Data type: `Optional[String]`

Package provider to manage the wormhole package with

Default value: ``undef``

## Tasks

### <a name="receive"></a>`receive`

Receive a file from a remote location

**Supports noop?** false

#### Parameters

##### `filename`

Data type: `String`

Remote filename

##### `code`

Data type: `String`

Wormhole code

### <a name="send"></a>`send`

Send a file from a remote location

**Supports noop?** false

#### Parameters

##### `filename`

Data type: `String`

Remote filename

